AWSTemplateFormatVersion: '2010-09-09'
Transform: 'AWS::Serverless-2016-10-31'

Resources:

  # Lambda Function para APIContact
  ContactFunction:
    Type: 'AWS::Serverless::Function'
    Properties:
      Handler: handler.apicontact
      CodeUri: ./apicontact
      Runtime: nodejs16.x
      MemorySize: 128
      Timeout: 30
      Policies:
        - AmazonSESFullAccess
      Environment:
        Variables:
          REGION: !Ref 'AWS::Region'
          SENDER_EMAIL: 'contacto@mycreditscore.cl'
      Events:
        ApiGateway:
          Type: 'Api'
          Properties:
            Path: /sendcontact
            Method: POST
            RestApiId:
              Ref: ApiGateway

  # Definición de la API Gateway
  ApiGateway:
    Type: AWS::Serverless::Api
    Properties:
      StageName: Prod
      DefinitionBody:
        swagger: '2.0'
        info:
          title: "API Contact MyCreditScore"
        paths:
          /sendcontact:
            post:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "200 response"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${ContactFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy
            options:
              consumes:
                - "application/json"
              produces:
                - "application/json"
              responses:
                "200":
                  description: "CORS support"
                  headers:
                    Access-Control-Allow-Origin:
                      type: "string"
                      default: "*"
                    Access-Control-Allow-Methods:
                      type: "string"
                      default: "POST, OPTIONS"
                    Access-Control-Allow-Headers:
                      type: "string"
                      default: "Content-Type,X-Amz-Date,Authorization,X-Api-Key,X-Amz-Security-Token"
              x-amazon-apigateway-integration:
                type: "mock"
                requestTemplates:
                  application/json: |
                    {
                      "statusCode": 200
                    }
                responses:
                  default:
                    statusCode: "200"
                    responseParameters:
                      method.response.header.Access-Control-Allow-Origin: "'*'"
                      method.response.header.Access-Control-Allow-Methods: "'POST, OPTIONS'"
                      method.response.header.Access-Control-Allow-Headers: "'Content-Type,X-Amz-Date,Authorization,X-Api-Key,X-Amz-Security-Token'"

Outputs:
  ApiContactUrl:
    Description: "ApiContact API Gateway endpoint URL"
    Value: !Sub "https://${ApiGateway}.execute-api.${AWS::Region}.amazonaws.com/Prod/sendcontact"

  ContactFunctionArn:
    Description: 'Lambda Function ARN'
    Value: !GetAtt ContactFunction.Arn
